	program QUOT
C
C PROGRAM WRITTEN BY ERIC YOUNGDALE
C		CARLETON COLLEGE
C		NORTHFIELD, MN    55057
C
C THIS PROGRAM WILL SEARCH THE DIRECTORY FILES AND ADD UP THE LENGTHS AND
C ALLOCATED SIZES OF ALL OF THE FILES THAT IT ENCOUNTERS. IT ALSO IDENTIFIES
C DIRECTORY FILES BY THE BIT SET IN THE INDEX FILE ON [0,0], AND CHECKS ALL
C OF THE SUBDIRECTORIES FOUND AS WELL, GIVING A TOTAL FOR EVERYTHING IN THE
C DIRECTORY STRUCTURE UNDER THE SPECIFIED DIRECTORY.
C	THIS PROGRAM IS A MODIFIED VERSION ON FDIR
C DIR_LIST IS DIMENSIONED FOR THE MAX NUMBER OF DIRS WE CAN HAVE.
C THIS IS A PIG ON MEMORY, SO NEXT REV WILL USE DYNAMIC STR. ALLOC.
	character*512 CIOLIST,CLIST
	CHARACTER*128 DIR_LIST(2048),ROOT,dname,TEMP,START,MSG
	CHARACTER*10 ACTION
	CHARACTER*7 CUIC
	character*4 DEV_NAME
	CHARACTER*3 JUNK
	CHARACTER*1 length
	BYTE Blength,Blength1,BID(2),BID1(2)
	LOGICAL*1 DTEMP,REAL_DIR,CREDIR
	INTEGER*4 DIR_COUNT,DIR_POINT,ZRLOC,ROOTL,DELTA,ID,STATUS
	INTEGER*4 FSIZE,FALLOC,TSIZE,TALLOC,TNUM,Tlength,FBYTE
	INTEGER*2 UIC
	EQUIVAlenCE (length,Blength),(CIOLIST,BID),(ID,BID1)
	COMMON /OWNER_UIC/ UIC(2),FSIZE,FALLOC,FBYTE
	data dev_name /'dra0'/
	CREDIR=.FALSE.
1	ACCEPT 1000,MSG
1000	format(a)
	CALL MOVEWORD(MSG,ACTION)
	IF (ACTION.NE.'BLKCHK') THEN
	  CALL SYS$BRDCST('%QUOT-E-ILLCMD, ILLEGAL COMMAND,"'
	1		//'\'//action//'\'//msg//'"','SYS$OUTPUT')
	  CALL EXIT(1)
	ENDIF
	CALL MOVEWORD(MSG,START)
	if (msg.ne.' ') CALL MOVEWORD(MSG,DEV_NAME)
2	dir_count=0
	dir_point=1
	root=dev_name
	root(5:13)=':[000000.'
	rootl=index(root,' ')
	dir_list(1)=root
	IF(INDEX(START,'[').NE.0) START=START(INDEX(START,'[')+1:128)
	IF(INDEX(START,']').NE.0) START=START(1:INDEX(START,']')-1)
	if(start.eq.'000000') then
	dir_list(1)(14:128)=start
	else
	root(rootl:128)=start
	rootl=index(root,' ')+1
	dir_list(1)=root
	root(rootl-1:rootl-1)='.'
	dir_count=1
	endif
5	dname=dir_list(dir_point)
	i=1
C
CTHIS IS THE START OF THE LOOP OF DIRECTORY FILES.
C
6	itmp=index(dname(i+1:128),'.')+i
	if(itmp.ne.i) then
	i=itmp
	goto 6
	endif
	dname(i:i)=']'
	i=index(dname,' ')
	dname(i:128)='.dir'
C WE HAVE FORMATTED A DIRECTORY NAME, NOW OPEN UP FILE FOR READING.
	open(unit=1,name=dname,type='old',recordtype='variable'
	1,readonly,shared,ERR=15)
C GET A FILE OUT OF THE DIRECTORY
10	read(1,1300,ERR=20) JUNK,length,Tlength,CIOLIST
1300	FORMAT(A3,A1,Q,A50)
	CLIST=CIOLIST(1:Blength)
	Blength1=Blength
	IF ((Blength.AND.1).EQ.1) Blength1=Blength1+1
	CIOLIST=CIOLIST(Blength1+3:512)
C NOW PLUCK OUT THE INDEX NUMBER OF THE FILE
13	BID1(2)=BID(2)
	BID1(1)=BID(1)
C AND SEE HOW LONG IT IS
	CALL VERIFY(DEV_NAME,ID,REAL_DIR)
	IF(FBYTE.EQ.0) FSIZE=FSIZE-1
C TALLY UP THE INFORMATION ABOUT THE FILE
	TSIZE=TSIZE+FSIZE
	TALLOC=TALLOC+FALLOC
	TNUM=TNUM+1
C DO NOT CHECK IF EXT IS '.DIR', USE INDEX FILE BIT ONLY.
	IF (REAL_DIR.EQ..FALSE.) GOTO 14
C A REAL DIRECTORY, ADD TO LIST, AND INCREMENT POINTERS
	dir_count=dir_count+1
	dir_list(dir_count)=root
C NOW CHECK TO SEE IF THIS WAS THE LAST VERSION OF THE FILE THAT EXISTS.
	dir_list(dir_count)(rootl:128)=clist(1:blength-4)
14	CIOLIST=CIOLIST(9:512)
	Blength1=Blength1+8
C IF ANOTHER VERSION, THEN TALLY IT ALSO, ELSE GET ANOTHER FILE FROM DIR
	IF(Blength1.GE.Tlength) GOTO 10
	GOTO 13
C HERE IS WHERE WE GO IF THERE IS AN ERROR ON FILE OPEN
15	DO 21 I=DIR_POINT,DIR_COUNT-1
21	DIR_LIST(I)=DIR_LIST(I+1)
C
C IF YOU WANT TO SEE WHICH DIRECTORIES ARE INACCESSABLE, YOU CAN LOOK HERE.
C YOU MUST DECIDE HOW TO SEND INFORMATION ABOUT THIS TO SYSTEM MANAGER OR
C TO THE OWNER.
C
	DIR_COUNT=DIR_COUNT-1
	GOTO 22
C HERE IS WHERE WE GO IF WE HAVE TALLIED ALL OF THE FILES IN THIS DIR
C WE SET UP THE NEXT DIR, AND GO BACK (IF THERE IS ANOTHER)
20	CLOSE (UNIT=1,ERR=25)
	DIR_POINT=DIR_POINT+1
22	ROOT=DIR_LIST(DIR_POINT)
	ROOTL=INDEX(ROOT,' ')+1
	ROOT(ROOTL-1:ROOTL-1)='.'
	IF(DIR_POINT.LE.DIR_COUNT) GOTO 5
25	CLOSE(UNIT=2)
C
C NOW WE ARE DONE SEARCHING, NOW PRINT OUT TOTALS.
C
	do 998 i=len(start),1,-1
	  if (start(i:i).ne.' ') goto 997
998	continue
997	ENCODE(128,99,MSG)TSIZE,TALLOC,TNUM,start(1:i)
99	FORMAT(1X,'TOTAL OF',I6,' /',I6,' IN',I5,' FILES under ',a)
	do 999 i=len(msg),1,-1
	  if (msg(i:i).ne.' ') then
	    CALL SYS$BRDCST(MSG(1:i),'SYS$OUTPUT')
	    call exit
	  endif
999	continue
	end



	SUBROUTINE VERIFY(DEV,REC,RESULT)
C THIS SUBROUTINE VERIFIES THAT A FILE WITH .DIR EXTENSION IS REALLY
C A DIRECTORY, AND NOT JUST ANOTHER FILE.
C IT ALSO RETURNS THE FILES UIC FOR THE CREATION FILE.
	IMPLICIT INTEGER(A-Z)
	COMMON /OWNER_UIC/ UIC(2),SIZE(2),ALLOC(2),FREEBYT
	INTEGER*2 UIC
	LOGICAL*1 RESULT
	INTEGER*2 INDEX(256),SIZE,ALLOC
	CHARACTER DEV*4,NAME*40
	DATA OFFSET/0/
C OFFSET IS CLUSTER*4+S(SIZE OF INDEX BIT MAP)
C (DO NOT ADD ONE, FORT REC STARTS WITH ONE, NOT ZERO)
	RESULT=.FALSE.
	IF(OFFSET.NE.0) GOTO 10
	NAME=DEV
	NAME(5:40)=':[0,0]INDEXF.SYS'
	OPEN(UNIT=2,NAME=NAME,READONLY,SHARED,TYPE='OLD'
	1,ACCESS='DIRECT',RECORDSIZE=128,FORM='UNFORMATTED')
	READ(2'2) INDEX
	C=INDEX(8)
	S=INDEX(17)
	OFFSET=C*4+S
10	READ(2'REC+OFFSET,ERR=20) INDEX
	IF(INDEX(27).EQ."20200) RESULT=.TRUE.
	UIC(1)=INDEX(31)
	UIC(2)=INDEX(32)
	SIZE(1)=INDEX(16)
	SIZE(2)=INDEX(15)
	ALLOC(1)=INDEX(14)
	ALLOC(2)=INDEX(13)
	FREEBYT=INDEX(17)
20	RETURN
	END
	SUBROUTINE MOVEWORD(START,FINISH)
	CHARACTER*(*) START,FINISH
	CALL CVT$$(START,24)
	I=INDEX(START,' ')
	FINISH=START(1:I)
	START=START(I+1:len(START))
	RETURN
	END
