PROCEDURE SLEEP(TMG,TNT:INTEGER);
/*
 *	SLEEP.PAS
 *
 *	17 April 1980
 *	Tim Yaukey and Les LaCroix
 *	Carleton College
 *	Northfield, Mn. 55057
 *
 *	Routine to sleep in OMSI Pascal-1.
 *
 *	Parameters:
 *		TMG - time magnitude.  Number of time units to sleep.
 *		TNT - time unit. Value ranges fromm 1 to 4:
 *			1 - ticks (1/100 second)
 *			2 - seconds
 *			3 - minutes
 *			4 - hours
 *
 *	Depending on the value of TNT, there may be limits on the value
 *	of TMG.  Please refer to VAX-11 Programmer's Manual.
 *
 *	This routine uses local event flag #1... beware.
 */
BEGIN
/*$C
.MCALL	MRKT$S,WTSE$S
	MRKT$S	#1, <TMG+4(%6)>, <TNT+2(%6)>	; Mark time; set LEF #1
						; when done.
	WTSE$S	#1				; Wait for flag to be set
*/
END /* SLEEP */;
