	PROGRAM FILDSP
C
C THIS PROGRAM DISPLAYS THE VALUABLE INFORMATION IN THE HEADER
C
	IMPLICIT INTEGER (A-Z)
C
C NEEDED PARAMETERS
C
	PARAMETER ATR$C_HEADER='A'X	!CODE FOR FILE HEADER
	PARAMETER ATR$S_HEADER='200'X	!SIZE OF FILE HEADER
	PARAMETER IO$_ACCESS='72'X	!ACCESS FILE
	PARAMETER IO$_DEACCESS='34'X	!DEACCESS FILE
C
C STORAGE
C
	CHARACTER FILE*100,CHRFIB*16,DEVICE*10,LINE*100,TIM1*24,
     1		  TIM2*24,MODE(0:3)*10,PROT(4)*4
	BYTE I1HEDR(0:511),I1FIB(16),I1WORD(4)
	INTEGER*2 I2HEDR(0:255),WORD(2),I2FIB(8),FID(3),DID(3),
     1		  I2ATR(6),IOSB(4)
	DIMENSION I4HEDR(0:127),I4FIB(4),I4ATR(3),PRIV(4),JPILST(4)
	EQUIVALENCE (I1HEDR,I2HEDR,I4HEDR),(I4WORD,WORD,I1WORD),
     1		    (CHRFIB,I1FIB,I2FIB,I4FIB),(FID,I1FIB(5)),
     2		    (DID,I1FIB(11)),(I2ATR,I4ATR)
	EQUIVALENCE (PRIV(1),DELPRV,WORPRV),(PRIV(2),EXEPRV,GRPPRV),
     1		    (PRIV(3),WRTPRV,OWNPRV),(PRIV(4),REDPRV,SYSPRV)
	DATA MODE/'USER','SUPERVISOR','EXEC','KERNAL'/
	DATA IN/-3/,OUT/-2/
10	JPILST(1)='03040004'X
	JPILST(2)=%LOC(I4WORD)
	JPILST(3)=0
	JPILST(4)=0
	STS=SYS$GETJPI(,,,JPILST,,,)
	TYPMAP=0
	IF(WORD(2).LE.'10'O) TYPMAP=1
	I4WORD=0
	WRITE(OUT,10000)
10000	FORMAT(' File name => '$)
	READ(IN,10010,END=130)LINLEN,LINE
10010	FORMAT(Q,A)
	IF(LINLEN.EQ.0) GOTO 130
	IF(TYPMAP.NE.0) THEN
	    WRITE(OUT,10020)
10020	    FORMAT(' Display map information (Y/N)? '$)
	    READ(IN,10030,END=130)ANSWER
10030	    FORMAT(A1)
	    IF(ANSWER.NE.'Y'.AND.ANSWER.NE.'y') TYPMAP=0
	    ENDIF
	CALL TRNLOG(LINE(1:LINLEN),FILE,FILEN)
	LOCOLN=LIB$LOCC(':',FILE(1:FILEN))
	IF(LOCOLN.NE.0) GOTO 20
	STS=SYS$TRNLOG('SYS$DISK',DEFLEN,LINE,,,)
	IF(.NOT.STS) CALL EXIT(STS)
	FILE=LINE(1:DEFLEN)//FILE(1:FILEN)
	FILEN=FILEN+DEFLEN
	LOCOLN=DEFLEN
20	DEVLEN=LOCOLN
	DEVICE=FILE(1:LOCOLN)
	STS=OPNFIL(FILE(1:FILEN),FID,DID)
	IF(.NOT.STS) THEN
	    WRITE(OUT,10040)FILE(1:FILEN),STS
10040	    FORMAT(' Error opening file ''',A,'''. Status: ',Z8)
	    GOTO 10
	    ENDIF
	TOTBLK=0
	TOTMAP=0
	HEADER=1
30	I2ATR(1)=ATR$S_HEADER
	I2ATR(2)=ATR$C_HEADER
	I4ATR(2)=%LOC(I1HEDR)
	I4ATR(3)=0
	STS=SYS$ASSIGN(DEVICE(1:DEVLEN),CHAN,,)
	IF(.NOT.STS) CALL EXIT(STS)
	STS=SYS$QIOW(,%VAL(CHAN),%VAL(IO$_ACCESS),IOSB,,,
     1		      CHRFIB(1:10),,,,I4ATR,)
	IF(.NOT.STS) CALL EXIT(STS)
	IF(.NOT.IOSB(1)) CALL EXIT(IOSB(1))
	STS=SYS$QIOW(,%VAL(CHAN),%VAL(IO$_DEACCESS),IOSB,,,
     1		      CHRFIB(1:10),,,,,)
	IF(.NOT.STS) CALL EXIT(STS)
	IF(.NOT.IOSB(1)) CALL EXIT(IOSB(1))
	STS=SYS$DASSGN(%VAL(CHAN))
	IF(.NOT.STS) CALL EXIT(STS)
	IF(HEADER.GT.1) GOTO 50
	WRITE(OUT,10050)I2HEDR(4),I2HEDR(5),I2HEDR(6)
10050	FORMAT(' File ID:',3(1X,O6))
	IDOF=I1HEDR(0)
	WRITE(OUT,10060)(I2HEDR(IDOF+IZZ),IZZ=0,9),I2HEDR(IDOF+10)
10060	FORMAT(' Created file name: ',10A2,' Revision number: ',I5)
	STS=SYS$ASCTIM(,TIM1(1:24),I2HEDR(IDOF+11),%VAL(0))
	STS=SYS$ASCTIM(,TIM2(1:24),I2HEDR(IDOF+15),%VAL(0))
	WRITE(OUT,10080)TIM1,TIM2
10080	FORMAT(' Creation date: ',A24,', Revision date: ',A24)
	STS=SYS$ASCTIM(,TIM1(1:24),I2HEDR(IDOF+19),%VAL(0))
	STS=SYS$ASCTIM(,TIM2(1:24),I2HEDR(IDOF+23),%VAL(0))
	WRITE(OUT,10100)TIM1,TIM2
10100	FORMAT(' Expiration date: ',A24,', Backup date: ',A24)
	FCHAR=I4HEDR(13)
	IF((FCHAR.AND.8).NE.0) WRITE(OUT,10110)
10110	FORMAT(' Verify all read operations.')
	IF((FCHAR.AND.16).NE.0) WRITE(OUT,10120)
10120	FORMAT(' Verify all write operations.')
	IF((FCHAR.AND.32).NE.0) WRITE(OUT,10130)
10130	FORMAT(' File is contiguous - best fit.')
	IF((FCHAR.AND.64).NE.0) WRITE(OUT,10140)
10140	FORMAT(' File is locked.')
	IF((FCHAR.AND.128).NE.0) WRITE(OUT,10150)
10150	FORMAT(' File is contiguous.')
	IF((FCHAR.AND.4096).NE.0) WRITE(OUT,10160)
10160	FORMAT(' File is an intermediate spool file.')
	IF((FCHAR.AND.8192).NE.0) WRITE(OUT,10170)
10170	FORMAT(' File is a directory file.')
	IF((FCHAR.AND.16384).NE.0) WRITE(OUT,10180)
10180	FORMAT(' File contains bad blocks.')
	IF((FCHAR.AND.32768).NE.0) WRITE(OUT,10190)
10190	FORMAT(' File is marked for deletion.')
	I4WORD=0
	I1WORD(1)=I1HEDR(59)
	DELPRV=(I4WORD.AND.'300'O)/(2**6)
	EXEPRV=(I4WORD.AND.'060'O)/(2**4)
	WRTPRV=(I4WORD.AND.'014'O)/(2**2)
	REDPRV=(I4WORD.AND.'003'O)
	WRITE(OUT,10200)(MODE(PRIV(IZZ)),IZZ=1,4)
10200	FORMAT(' Accessor privilege level:',
     1	       ' Read: ',A/
     2	       ' 	Write: ',A,
     3	       ' Execute: ',A,
     4	       ' Delete: ',A)
	I4WORD=I4HEDR(15)
	WRITE(OUT,10210)WORD(2),WORD(1)
10210	FORMAT(' File owner: [',O6,',',O6,']')
	I4WORD=0
	WORD(1)=I2HEDR(32)
	WORPRV=(I4WORD.AND.'F000'X)/(2**12)
	GRPPRV=(I4WORD.AND.'0F00'X)/(2**8)
	OWNPRV=(I4WORD.AND.'00F0'X)/(2**4)
	SYSPRV=(I4WORD.AND.'000F'X)
	DO 40 I=1,4
	PROT(I)=' '
	IF((PRIV(I).AND.'1'X).EQ.0) THEN
	    PROT(I)(1:1)='R'
	    ENDIF
	IF((PRIV(I).AND.'2'X).EQ.0) THEN
	    PROT(I)(2:2)='W'
	    ENDIF
	IF((PRIV(I).AND.'4'X).EQ.0) THEN
	    PROT(I)(3:3)='E'
	    ENDIF
	IF((PRIV(I).AND.'8'X).EQ.0) THEN
	    PROT(I)(4:4)='D'
	    ENDIF
40	CONTINUE
	WRITE(OUT,10220)(PROT(IZZ),IZZ=4,1,-1)
10220	FORMAT(' File protection: (',A,',',A,',',A,',',A,')')
	IF(I2HEDR(7).NE.0) WRITE(OUT,10230)
10230	FORMAT(' File contains extension headers.')
	USRATR=10
	RTYP=I1HEDR(USRATR*2)
	IF(RTYP.EQ.0) WRITE(OUT,10240)
10240	FORMAT(' File has undefined record format.')
	IF(RTYP.EQ.1) WRITE(OUT,10250)
10250	FORMAT(' File has fixed length records.')
	IF(RTYP.EQ.2) WRITE(OUT,10260)
10260	FORMAT(' File has variable length records.')
	IF(RTYP.EQ.3) WRITE(OUT,10270)
10270	FORMAT(' File has variable length records',
     1	       ' with fixed length control.')
	RATT=I1HEDR(USRATR*2+1)
	IF((RATT.AND.1).NE.0) WRITE(OUT,10280)
10280	FORMAT(' File uses standard Fortran carriage control.')
	IF((RATT.AND.2).NE.0) WRITE(OUT,10290)
10290	FORMAT(' File uses implied carriage control',
     1	       ' (CR before, LF after)')
	IF((RATT.AND.4).NE.0) WRITE(OUT,10300)
10300	FORMAT(' File uses print type carriage control.')
	IF((RATT.AND.8).NE.0) WRITE(OUT,10310)
10310	FORMAT(' Records do not cross block boundaries.')
	RSIZ=I2HEDR(USRATR+1)
	MRS=I2HEDR(USRATR+8)
	WRITE(OUT,10320)RSIZ,MRS
10320	FORMAT(' Record size: ',I5,', Maximum record size: ',I5)
	WORD(1)=I2HEDR(USRATR+3)
	HIBK=I4WORD
	WORD(1)=I2HEDR(USRATR+2)
	HIBK=HIBK+I4WORD*(2**16)
	WRITE(OUT,10330)HIBK
10330	FORMAT(' Highest virtual block allocated: ',I7)
	WORD(1)=I2HEDR(USRATR+5)
	EFBK=I4WORD
	WORD(1)=I2HEDR(USRATR+4)
	EFBK=EFBK+I4WORD*(2**16)
	WORD(1)=I2HEDR(USRATR+6)
	WRITE(OUT,10340)EFBK,I4WORD
10340	FORMAT(' End of File block: ',I7,
     1	       ', First free byte in EOF block: ',I5)
	BKTSZ=I1HEDR(USRATR*2+14)
	EXQ=I2HEDR(USRATR+9)
	WRITE(OUT,10360)BKTSZ,EXQ
10360	FORMAT(' Bucket size in blocks: ',I3,
     1	       ', Default extend quantity: ',I5)
	VFCSZ=I1HEDR(USRATR*2+15)
	WRITE(OUT,10370)VFCSZ
10370	FORMAT(' Fixed length control size in bytes: ',I3)
50	START=I1HEDR(1)
	NEXT=START
60	WORD(1)=I2HEDR(NEXT)
	CODE=I4WORD/(2**14)
	GOTO (70,80,90,100) CODE+1
	STOP
70	IF(TYPMAP.NE.0) WRITE(OUT,10400)I2HEDR(NEXT)
10400	FORMAT(' PLACEMENT= ',I10)
	NEXT=NEXT+1
	GOTO 110
80	WORD(1)=I2HEDR(NEXT).AND.'037400'O
	LBN=I4WORD*(2**8)
	WORD(1)=I2HEDR(NEXT+1)
	LBN=LBN+I4WORD
	COUNT=I2HEDR(NEXT).AND.'000377'O
	IF(TYPMAP.NE.0) WRITE(OUT,10410)LBN,COUNT+1
10410	FORMAT(' LBN= ',I10,' Count= ',I10)
	NEXT=NEXT+2
	GOTO 110
90	WORD(1)=I2HEDR(NEXT+2)
	LBN=I4WORD*(2**16)
	WORD(1)=I2HEDR(NEXT+1)
	LBN=LBN+I4WORD
	COUNT=I2HEDR(NEXT).AND.'037777'O
	IF(TYPMAP.NE.0) WRITE(OUT,10410)LBN,COUNT+1
	NEXT=NEXT+3
	GOTO 110
100	WORD(1)=I2HEDR(NEXT+3)
	LBN=I4WORD*(2**16)
	WORD(1)=I2HEDR(NEXT+2)
	LBN=LBN+I4WORD
	WORD(1)=I2HEDR(NEXT).AND.'037777'O
	COUNT=I4WORD*(2**16)
	WORD(1)=I2HEDR(NEXT+1)
	COUNT=COUNT+I4WORD
	IF(TYPMAP.NE.0) WRITE(OUT,10410)LBN,COUNT+1
	NEXT=NEXT+4
110	TOTMAP=TOTMAP+1
	TOTBLK=TOTBLK+COUNT+1
	IF(NEXT.LT.START+I2HEDR(29)) GOTO 60
	IF(I2HEDR(7).EQ.0) GOTO 120
	FID(1)=I2HEDR(7)
	FID(2)=I2HEDR(8)
	FID(3)=I2HEDR(9)
	HEADER=HEADER+1
	GOTO 30
120	WRITE(OUT,10420)TOTBLK,TOTMAP
10420	FORMAT(' Total of ',I6,' blocks mapped in ',I6,' map pointers.')
	CLOSE(UNIT=10)
	GOTO 10
130	CONTINUE
	END
