$ ! ********** FIXHEADER program builder **********
$ !
$ ! VICKI W. WOOLF
$ ! PROGRAM OF COMPUTER GRAPHICS - CORNELL UNIVERSITY
$ ! 120 RAND HALL   ITHACA   NEW YORK   14853   (607) 256-7444
$
$
$ !	Set up noverify, error and abort branches
$
$ OLD_VERIFY = 'F$VERIFY()
$ SET NOVERIFY
$ ON ERROR THEN GOTO ERROR_BRANCH
$ ON WARNING THEN GOTO ERROR_BRANCH
$ ON SEVERE_ERROR THEN GOTO ERROR_BRANCH
$ ON CONTROL_Y THEN GOTO ABORT_BRANCH
$
$
$ !	Compile module  allowing "D" for debugging
$
$ DEBUG := FALSE
$ IF P1 .EQS. "D" THEN DEBUG := TRUE
$
$ WRITE  SYS$OUTPUT  "Compiling and assembling..."
$ IF DEBUG THEN FORTRAN/CONT=99/DEBUG/NOOPT/CHECK=ALL/D_LINES FIXHEADER
$ IF .NOT. DEBUG THEN FORTRAN/CONT=99/NODEBUG/OPTIMIZE/NOCHECK/NOD_LINES -
	FIXHEADER
$ IF DEBUG THEN MAC/ENABL=(DBG)/OBJECT=FIXHEADM.OBJ FIXHEADER
$ IF .NOT. DEBUG THEN MAC/OBJECT=FIXHEADM.OBJ FIXHEADER
$
$ WRITE  SYS$OUTPUT "Linking program..."
$ IF DEBUG THEN  LINK/DEBUG FIXHEADER,FIXHEADM
$ IF .NOT. DEBUG THEN LINK FIXHEADER,FIXHEADM
$
$ WRITE  SYS$OUTPUT  "--- FIXHEADER built."
$ DELETE FIXHEADER.OBJ;*,FIXHEADM.OBJ;*
$ IF OLD_VERIFY THEN SET VERIFY
$ EXIT
$
$
$ !	On error or abort, type error message and delete object modules
$
$ ERROR_BRANCH:
$ WRITE  SYS$OUTPUT  "--- Errors stop program build."
$ DELETE FIXHEADER.OBJ;*,FIXHEADM.OBJ;*
$ IF OLD_VERIFY THEN SET VERIFY
$ EXIT %X2C
$
$ ABORT_BRANCH:
$ WRITE  SYS$OUTPUT  "--- ^Y terminates program build."
$ DELETE FIXHEADER.OBJ;*,FIXHEADM.OBJ;*
$ IF OLD_VERIFY THEN SET VERIFY
$ EXIT %X614
