C********** VMP return status code definitions **********

C  Definition of VMP maximum return status code

	PARAMETER VMP$MAX_STATUS = 15

C  Definition of VMP non-severe return status codes
C  (No error reported by VMP$)

	PARAMETER  VMP$_NORMAL = 1,	! Normal completion
	2          VMP$_OPEFAI = 2	! Open failure on file

C  Definition of VMP severe return status codes
C  (Severe error reported by VMP$)

	PARAMETER VMP$_BADRET = 3	! Bad return status
	PARAMETER VMP$_INVPAR = 4	! Invalid parameter
	PARAMETER VMP$_INVFIL = 5	! Invalid filespec
	PARAMETER VMP$_OPNFIL = 6	! Open failure
	PARAMETER VMP$_CLSFIL = 7	! Close failure
	PARAMETER VMP$_EXTFAI = 8	! Extend failure
	PARAMETER VMP$_UPDFAI = 9	! Update failure
	PARAMETER VMP$_TRNFAI = 10	! Truncate fail
	PARAMETER VMP$_MAPFAI = 11	! Map section failure
	PARAMETER VMP$_VAFAI  = 12	! Expand virtual address space failure
	PARAMETER VMP$_DVAFAI = 13	! Delete virtual address space failure
	PARAMETER VMP$_ERRHDRUPD=14	! Error on header update
	PARAMETER VMP$_NOTMAP = 15	! Tried to access an unmapped file

