$ SET NOCONTROL_Y
$ ON ERROR THEN GOTO CLEANUP
$ SET DEFAULT SYS$SYSTEM
$ ASSIGN/USER TERM.SXX SYS$OUTPUT
$ SHOW TERMINAL
$ OPEN/READ TDATA TERM.SXX
$ CLOSE TDATA
$ OPEN/READ TDATA TERM.SXX
$ READ/END=CLEANUP TDATA TREC
$ FTERM='F$LOC("OPA0:",TREC)+1
$ SIZE='F$LENGTH(TREC)-FTERM
$ IF SIZE .GT. 0 THEN GOTO CONT
$ WRITE SYS$OUTPUT "	Rollout must be run from terminal OPA0."
$ GOTO CLEANUP
$CONT:
$ WRITE SYS$OUTPUT "	System rollout command procedure."
$ WRITE SYS$OUTPUT "	All magtape volumes should be dismounted."
$ WRITE SYS$OUTPUT "	All disk packs to be used in another system"
$ WRITE SYS$OUTPUT "	be dismounted prior to continuing."
$ INQUIRE CONTINUE DO YOU WISH TO CONTINUE [Y/N]?
$ IF CONTINUE .NES. "Y" THEN GOTO CLEANUP
$ SHOW TIME
$ INQUIRE TOGO HOW MANY MINUTES UNTIL ROLLOUT?
$ TOGO='TOGO
$ INQUIRE WHY REASON?
$ SET LOGIN/INTERACTIVE=0
$ WRITE SYS$OUTPUT "	Non-operator logins are disabled."
$ REPLY/ENABLE
$ BATCH=0
$ LOOP:
$ IF TOGO .GT. 4 .OR. BATCH .EQ. 1 THEN GOTO NOTIFY
$ BATCH=1
$ ASSIGN/USER QUEUE.SXX SYS$OUTPUT
$ SHOW QUEUE /BATCH
$ ASSIGN/USER QUEUE2.SXX SYS$OUTPUT
$ SHOW QUEUE /DEVICE
$ COPY QUEUE.SXX,QUEUE2.SXX QUEUE.SXX
$ OPEN QDATA QUEUE.SXX
$ GNQ:
$	READ/END=WAITL QDATA QREC
$	FQUOTE='F$LOC("""",QREC)+1
$	SIZE='F$LENGTH(QREC)-FQUOTE
$	IF SIZE .LE. 0 THEN GOTO GNQ
$		LQUOTE='F$LOCATE(""" ",QREC)
$		SIZE=LQUOTE-FQUOTE
$		QNAME:='F$EXTRACT(FQUOTE,SIZE,QREC)
$		STOP /QUEUE/NEXT 'QNAME
$	GOTO GNQ
$ WAITL:
$ REPLY/ALL "BATCH AND DEVICE QUEUES HAVE BEEN STOPPED"
$ NOTIFY:
$ REASON:=""""'WHY
$ UNIT:=MINUTES.
$ IF TOGO .EQ. 1 THEN UNIT:=MINUTE.
$ A:="""SYSTEM SHUTDOWN IN "'TOGO 'UNIT " LOGINS ARE DISABLED, PLEASE LOGOFF.
$	REPLY/ALL/BELL 'A
$	REPLY/ALL/BELL 'REASON
$	IF TOGO .EQ. 0 THEN GOTO FINISH
	TOGO=TOGO/2
$	DURAT=TOGO
$	IF DURAT .EQ. 0 THEN DURAT=1
$	WAIT 00:'DURAT
$	GOTO LOOP
$ FINISH:
!
$ WRITE SYS$OUTPUT "	Shut down network."
$ ASSIGN/USER NDATA.SXX SYS$OUTPUT
$ SHOW NET
$ RUN SYS$SYSTEM:NCP
SET STATE LOCAL SHUT
EXIT
$ SET NOON
$ REN SYS$SYSTEM:ROLLIN.EXE SYS$SYSTEM:SYSBOOT.EXE
$ ASSIGN/USER OPA0: SYS$INPUT
$ DEFINE/USER ROLLFLAG ROLLOUT
$ DEFINE/USER NODELETE C7_XX	!TERMINALS FOR WHICH PROCESSES WILL NOT BE DELETED
$ RUN SYS$SYSTEM:ROLLOUT
$ REN SYS$SYSTEM:SYSBOOT.EXE SYS$SYSTEM:ROLLIN.EXE
$ ON ERROR THEN GOTO CLEANUP
!
$ OPEN NDATA NDATA.SXX
$GNN:
$	READ/END=NEND NDATA NREC
$	FSTATE='F$LOC("STATE: ON",NREC)
$	IF ('F$LENGTH(NREC)-FSTATE) .LE. 0 THEN GOTO GNN
$ RUN SYS$SYSTEM:NCP
SET STATE LOCAL ON
EXIT
$NEND:
$ INQUIRE CONTINUE DO YOU WANT COMMAND PROCEDURE TO RESTORE QUEUES [Y/N]?
$ IF CONTINUE .NES. "Y" THEN GOTO CLEANUP
$ CLOSE QDATA
$ OPEN QDATA QUEUE.SXX
$ GNQ1:
$	READ/END=QMES QDATA QREC
$	FQUOTE='F$LOC("""",QREC)+1
$	SIZE='F$LENGTH(QREC)-FQUOTE
$	IF SIZE .LE. 0 THEN GOTO GNQ1
$		LQUOTE='F$LOCATE(""" ",QREC)
$		SIZE=LQUOTE-FQUOTE
$		QNAME:='F$EXTRACT(FQUOTE,SIZE,QREC)
$		LSTOP='F$LOCATE("Stopped",QREC)
$		IF ('F$LENGTH(QREC)-LSTOP) .GT. 0 THEN GOTO GNQ1
$		START /QUEUE 'QNAME
$	GOTO GNQ1
$QMES:
$ WRITE SYS$OUTPUT "	Rollin has restored queues to their pre-rollout states."
$ CLEANUP:
$ CLOSE TDATA
$ CLOSE NDATA
$ CLOSE QDATA
$ DELETE *.SXX;*
$EXIT:
$ SET LOGIN/INTERACTIVE=64
$ WRITE SYS$OUTPUT "	Rollin operations complete."
